package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.motion.*;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_0_0_spawnbehaviour extends ActorScript
{
	public var _frequency:Float;
	public var _whattospawn:ActorType;
	public var _direction:String;
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("Actor", "actor");
		nameMap.set("frequency", "_frequency");
		_frequency = 1.0;
		nameMap.set("what to spawn", "_whattospawn");
		_whattospawn = getActorType(88);
		nameMap.set("direction", "_direction");
		_direction = "0";
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		actor.disableActorDrawing();
		
		/* ======================= Every N seconds ======================== */
		runPeriodically(1000 * _frequency, function(timeTask:TimedTask):Void
		{
			if(wrapper.enabled)
			{
				createRecycledActor(_whattospawn, actor.getXCenter(), actor.getYCenter(), Script.MIDDLE);
				getLastCreatedActor().moveToLayer(engine.getLayerById(actor.getLayerID()));
				getLastCreatedActor().setXCenter(actor.getXCenter());
				getLastCreatedActor().setYCenter(actor.getYCenter());
				if((_direction == "n"))
				{
					getLastCreatedActor().moveBy(-0, -12, 1, Easing.linear);
				}
				if((_direction == "e"))
				{
					getLastCreatedActor().moveBy(12, 0, 1, Easing.linear);
				}
				if((_direction == "s"))
				{
					getLastCreatedActor().moveBy(-0, 12, 1, Easing.linear);
				}
				if((_direction == "w"))
				{
					getLastCreatedActor().moveBy(-12, 0, 1, Easing.linear);
				}
			}
		}, actor);
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}