package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.motion.*;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_1_1_2wayenemy extends ActorScript
{
	public var _walkingR:String;
	public var _walkingL:String;
	public var _dead:Bool;
	public var _inmoveR:Bool;
	public var _secondsofwalk:Float;
	public var _speedofwalk:Float;
	public var _x:Float;
	public var _y:Float;
	public var _rest:Float;
	public var _directionchange:Float;
	public var _startdirR:Bool;
	public var _readytowalk:Bool;
	public var _xspeed:Float;
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("Actor", "actor");
		nameMap.set("walking R", "_walkingR");
		nameMap.set("walking L", "_walkingL");
		nameMap.set("dead", "_dead");
		_dead = false;
		nameMap.set("in move R", "_inmoveR");
		_inmoveR = true;
		nameMap.set("seconds of walk", "_secondsofwalk");
		_secondsofwalk = 0.0;
		nameMap.set("speed of walk", "_speedofwalk");
		_speedofwalk = 5.0;
		nameMap.set("x", "_x");
		_x = 0.0;
		nameMap.set("y", "_y");
		_y = 0.0;
		nameMap.set("rest", "_rest");
		_rest = 0.0;
		nameMap.set("direction change", "_directionchange");
		_directionchange = 0.0;
		nameMap.set("start dir R", "_startdirR");
		_startdirR = false;
		nameMap.set("ready to walk", "_readytowalk");
		_readytowalk = false;
		nameMap.set("x speed", "_xspeed");
		_xspeed = 5.0;
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		if((_startdirR == true))
		{
			actor.setXVelocity(15);
		}
		else
		{
			actor.setXVelocity(-15);
		}
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}